// RegionCreatorTestView.cpp : implementation of the CRegionCreatorTestView class
//

#include "stdafx.h"
#include "RegionCreatorTest.h"
#include "RegionCreatorTestDoc.h"
#include "RegionCreatorTestView.h"
#include "RegionCreator.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

WNDPROC OldWndProc = NULL;
LRESULT CALLBACK NewWndProc(HWND hwnd, UINT uMsg, WPARAM wParam, LPARAM lParam);
BITMAPINFOHEADER g_BIH;
unsigned char* g_pBits = NULL;
BOOL g_Skined = TRUE;
BOOL g_Tested = TRUE;

/////////////////////////////////////////////////////////////////////////////
// CRegionCreatorTestView

IMPLEMENT_DYNCREATE(CRegionCreatorTestView, CView)

BEGIN_MESSAGE_MAP(CRegionCreatorTestView, CView)
	//{{AFX_MSG_MAP(CRegionCreatorTestView)
	ON_COMMAND(ID_REGIONCREATOR_TEST, OnRegioncreatorTest)
	ON_COMMAND(ID_REGIONCREATOR_SKINNED, OnRegioncreatorSkinned)
	ON_UPDATE_COMMAND_UI(ID_REGIONCREATOR_SKINNED, OnUpdateRegioncreatorSkinned)
	ON_UPDATE_COMMAND_UI(ID_REGIONCREATOR_TEST, OnUpdateRegioncreatorTest)
	//}}AFX_MSG_MAP
	// Standard printing commands
	ON_COMMAND(ID_FILE_PRINT, CView::OnFilePrint)
	ON_COMMAND(ID_FILE_PRINT_DIRECT, CView::OnFilePrint)
	ON_COMMAND(ID_FILE_PRINT_PREVIEW, CView::OnFilePrintPreview)
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CRegionCreatorTestView construction/destruction

CRegionCreatorTestView::CRegionCreatorTestView()
{
	// TODO: add construction code here

	m_hBitmap = NULL;
	m_pBits = NULL;
	m_hRgn = NULL;
}

CRegionCreatorTestView::~CRegionCreatorTestView()
{
	SetWindowLong(m_Wnd.m_hWnd, GWL_WNDPROC, (LONG)OldWndProc);
	
	if ( m_hBitmap != NULL )
	{
		DeleteObject(m_hBitmap);
		m_hBitmap = NULL;

		if ( m_pBits != NULL )
			delete m_pBits;
		m_pBits = NULL;
	}

	if ( m_hRgn != NULL )
	{
		DeleteObject(m_hRgn);
		m_hRgn = NULL;
	}
}

BOOL CRegionCreatorTestView::PreCreateWindow(CREATESTRUCT& cs)
{
	// TODO: Modify the Window class or styles here by modifying
	//  the CREATESTRUCT cs

	return CView::PreCreateWindow(cs);
}

/////////////////////////////////////////////////////////////////////////////
// CRegionCreatorTestView drawing

void CRegionCreatorTestView::OnDraw(CDC* pDC)
{
	CRegionCreatorTestDoc* pDoc = GetDocument();
	ASSERT_VALID(pDoc);
	// TODO: add draw code for native data here

	if ( m_hBitmap != NULL )
		StretchDIBits(pDC->m_hDC, 0, m_BIH.biHeight-1, m_BIH.biWidth, -m_BIH.biHeight, 0, 0, m_BIH.biWidth, m_BIH.biHeight, m_pBits, (BITMAPINFO*)&m_BIH, BI_RGB, SRCCOPY);
}

/////////////////////////////////////////////////////////////////////////////
// CRegionCreatorTestView printing

BOOL CRegionCreatorTestView::OnPreparePrinting(CPrintInfo* pInfo)
{
	// default preparation
	return DoPreparePrinting(pInfo);
}

void CRegionCreatorTestView::OnBeginPrinting(CDC* /*pDC*/, CPrintInfo* /*pInfo*/)
{
	// TODO: add extra initialization before printing
}

void CRegionCreatorTestView::OnEndPrinting(CDC* /*pDC*/, CPrintInfo* /*pInfo*/)
{
	// TODO: add cleanup after printing
}

/////////////////////////////////////////////////////////////////////////////
// CRegionCreatorTestView diagnostics

#ifdef _DEBUG
void CRegionCreatorTestView::AssertValid() const
{
	CView::AssertValid();
}

void CRegionCreatorTestView::Dump(CDumpContext& dc) const
{
	CView::Dump(dc);
}

CRegionCreatorTestDoc* CRegionCreatorTestView::GetDocument() // non-debug version is inline
{
	ASSERT(m_pDocument->IsKindOf(RUNTIME_CLASS(CRegionCreatorTestDoc)));
	return (CRegionCreatorTestDoc*)m_pDocument;
}
#endif //_DEBUG

/////////////////////////////////////////////////////////////////////////////
// CRegionCreatorTestView message handlers

void CRegionCreatorTestView::OnInitialUpdate() 
{
	CView::OnInitialUpdate();
	
	// TODO: Add your specialized code here and/or call the base class
	
	m_hBitmap = (HBITMAP)LoadImage(NULL, "res\\image.bmp", IMAGE_BITMAP, 0, 0, LR_LOADFROMFILE);

	if ( m_hBitmap != NULL )
	{
		BITMAP bitmap;
		GetObject(m_hBitmap, sizeof(BITMAP), &bitmap);
		DWORD dwSize = bitmap.bmWidthBytes * bitmap.bmHeight;

		ZeroMemory(&m_BIH, sizeof(BITMAPINFOHEADER));
		m_BIH.biSize = sizeof(BITMAPINFOHEADER);
		m_BIH.biBitCount = bitmap.bmBitsPixel;
		m_BIH.biHeight = bitmap.bmHeight;
		m_BIH.biPlanes = 1;
		m_BIH.biWidth = bitmap.bmWidth;
		m_BIH.biSizeImage = dwSize;

		if ( m_pBits != NULL )
			delete m_pBits;
		m_pBits = new unsigned char[dwSize];
		GetBitmapBits(m_hBitmap, dwSize, m_pBits);
		m_TransparentColor = RGB(m_pBits[2], m_pBits[1], m_pBits[0]);

		RECT rect = {100, 200, 100+m_BIH.biWidth, 200+m_BIH.biHeight};
		m_Wnd.Create(NULL, "Test Window", WS_CHILD | WS_VISIBLE, rect, this, 0x10000, NULL);
		OldWndProc = (WNDPROC)SetWindowLong(m_Wnd.m_hWnd, GWL_WNDPROC, (LONG)NewWndProc);
		g_BIH = m_BIH;
		g_pBits = m_pBits;
	}
}

void CRegionCreatorTestView::OnRegioncreatorTest() 
{
	// TODO: Add your command handler code here
	
	CRegionCreator regionCreator;
	
	if ( m_hRgn != NULL )
		DeleteObject(m_hRgn);
	m_hRgn = regionCreator.CreateRegionFromBitmap(m_hBitmap, m_TransparentColor);

	m_Wnd.SetWindowRgn(m_hRgn, TRUE);

	g_Tested = FALSE;
}

LRESULT CALLBACK NewWndProc(HWND hwnd, UINT uMsg, WPARAM wParam, LPARAM lParam)
{
	switch (uMsg)
	{
		case WM_PAINT:
		{
			PAINTSTRUCT ps;
			::BeginPaint(hwnd, &ps);

			if ( g_Skined == TRUE )
			{
				// Show loaded bitmap
				StretchDIBits(ps.hdc, 0, g_BIH.biHeight-1, g_BIH.biWidth, -g_BIH.biHeight, 0, 0, g_BIH.biWidth, g_BIH.biHeight, g_pBits, (BITMAPINFO*)&g_BIH, BI_RGB, SRCCOPY);
			}
			else
			{
				// Show region
				HBRUSH hBrush = CreateHatchBrush(HS_DIAGCROSS, RGB(0,255,0));
				RECT rect;
				::GetClientRect(hwnd, &rect);
				FillRect(ps.hdc, &rect, hBrush);
				DeleteObject(hBrush);
			}

			// Draw some text
			::SetBkMode(ps.hdc, TRANSPARENT);
			CString strText = "Click and drag to move me...";
			TextOut(ps.hdc, 65, 12, strText, strText.GetLength());
			::SetBkMode(ps.hdc, OPAQUE);

			::EndPaint(hwnd, &ps);
		}
		break;

		case WM_LBUTTONDOWN:
		{
			// Move window free
			::SendMessage(hwnd, WM_NCLBUTTONDOWN, (WPARAM)HTCAPTION, NULL);
		}
		break;

		default:
			return CallWindowProc(OldWndProc, hwnd, uMsg, wParam, lParam);
	}

	return 0;
}

void CRegionCreatorTestView::OnRegioncreatorSkinned() 
{
	// TODO: Add your command handler code here
	
	g_Skined = !g_Skined;

	::InvalidateRect(m_Wnd.m_hWnd, NULL, TRUE);
	::UpdateWindow(m_Wnd.m_hWnd);
}

void CRegionCreatorTestView::OnUpdateRegioncreatorSkinned(CCmdUI* pCmdUI) 
{
	// TODO: Add your command update UI handler code here
	
	pCmdUI->SetCheck(g_Skined);
}

void CRegionCreatorTestView::OnUpdateRegioncreatorTest(CCmdUI* pCmdUI) 
{
	// TODO: Add your command update UI handler code here
	
	pCmdUI->Enable(g_Tested);
}
